    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one or more
    003 * contributor license agreements.  See the NOTICE file distributed with
    004 * this work for additional information regarding copyright ownership.
    005 * The ASF licenses this file to You under the Apache License, Version 2.0
    006 * (the "License"); you may not use this file except in compliance with
    007 * the License.  You may obtain a copy of the License at
    008 *
    009 *      https://www.apache.org/licenses/LICENSE-2.0
    010 *
    011 * Unless required by applicable law or agreed to in writing, software
    012 * distributed under the License is distributed on an "AS IS" BASIS,
    013 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    014 * See the License for the specific language governing permissions and
    015 * limitations under the License.
    016 */
    017
    018package org.apache.commons.codec;
    019
    020/**
    021 * Provides the highest level of abstraction for Decoders.
    022 * <p>
    023 * This is the sister interface of {@link Encoder}. All Decoders implement this common generic interface.
    024 * Allows a user to pass a generic Object to any Decoder implementation in the codec package.
    025 * </p>
    026 * <p>
    027 * One of the two interfaces at the center of the codec package.
    028 * </p>
    029 */
    030public interface Decoder {
    031
    032    /**
    033     * Decodes an "encoded" Object and returns a "decoded" Object. Note that the implementation of this interface will
    034     * try to cast the Object parameter to the specific type expected by a particular Decoder implementation. If a
    035     * {@link ClassCastException} occurs this decode method will throw a DecoderException.
    036     *
    037     * @param source
    038     *            the object to decode
    039     * @return a 'decoded" object
    040     * @throws DecoderException
    041     *             a decoder exception can be thrown for any number of reasons. Some good candidates are that the
    042     *             parameter passed to this method is null, a param cannot be cast to the appropriate type for a
    043     *             specific encoder.
    044     */
    045    Object decode(Object source) throws DecoderException;
    046}
    047